diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -556,141 +724,706 @@
     }
     if (current_buddy) {
       if (buddy_gettype(BUDDATA(current_buddy)) & ROSTER_TYPE_GROUP)
-        do_group("toggle");
+        group_cmd (BUDDATA(current_buddy), scmd_group_toggle);
       else {
         // Enter chat mode
         scr_set_chatmode(TRUE);
         scr_show_buddy_window();
       }
     }
-    return 0;
+    return cmd_result_input;
   }
 
-  if (*line != COMMAND_CHAR) {
-    // This isn't a command
+  utf8 = to_utf8(line);
+  if (*line != COMMAND_CHAR) { // input line
     if (scr_get_multimode())
-      scr_append_multiline(line);
+      scr_append_multiline(utf8);
     else
-      say_cmd((char*)line, 0);
-    return 0;
-  }
-
-  /* It is _probably_ a command -- except for verbatim multi-line mode */
-  return process_command(line, FALSE);
-}
-
-// Helper routine for buffer item_{lock,unlock,toggle_lock}
-// "lock" values: 1=lock 0=unlock -1=invert
-static void roster_buddylock(char *bjid, int lock)
-{
-  gpointer bud = NULL;
-  bool may_need_refresh = FALSE;
-
-  // Allow special jid "" or "." (current buddy)
-  if (bjid && (!*bjid || !strcmp(bjid, ".")))
-    bjid = NULL;
-
-  if (bjid) {
-    // The JID has been specified.  Quick check...
-    if (check_jid_syntax(bjid)) {
-      scr_LogPrint(LPRINT_NORMAL|LPRINT_NOTUTF8,
-                   "<%s> is not a valid Jabber ID.", bjid);
-    } else {
-      // Find the buddy
-      GSList *roster_elt;
-      roster_elt = roster_find(bjid, jidsearch,
-                               ROSTER_TYPE_USER|ROSTER_TYPE_ROOM);
-      if (roster_elt)
-        bud = roster_elt->data;
-      else
-        scr_LogPrint(LPRINT_NORMAL, "This jid isn't in the roster.");
-      may_need_refresh = TRUE;
-    }
-  } else {
-    // Use the current buddy
-    if (current_buddy)
-      bud = BUDDATA(current_buddy);
-  }
-
-  // Update the ROSTER_FLAG_USRLOCK flag
-  if (bud) {
-    if (lock == -1)
-      lock = !(buddy_getflags(bud) & ROSTER_FLAG_USRLOCK);
-    buddy_setflags(bud, ROSTER_FLAG_USRLOCK, lock);
-    if (may_need_refresh) {
-      buddylist_build();
-      update_roster = TRUE;
+      say_cmd(utf8, msgtype_not_set);
+    retval = 0;
+  } else { // command or verbatim multiline message
+    retval = cmd_execute (utf8, cmdexe_check_verbatim);
+    if (retval == cmd_result_verbatim) {
+      g_free(utf8); // buffer has been corrupted by parser
+      utf8 = to_utf8(line);
+      scr_append_multiline(utf8);
+      retval = cmd_result_input;
     }
   }
+  g_free(utf8);
+
+  return retval;
 }
 
-static void roster_resourcelock(char *jidres, gboolean lock) {
-  gpointer bud = NULL;
-  char *resource = NULL;
-
-  if (!jidres) {
-    if (lock) return;
-    jidres = ".";
-  }
-
-  if (jidres[0] == '.' &&
-      (jidres[1] == '\0' || jidres[1] == JID_RESOURCE_SEPARATOR)) {
-    //Special jid: . or ./resource
-    switch (jidres[1]) {
-      case JID_RESOURCE_SEPARATOR:
-        resource = jidres+2;
-      case '\0':
-        if (current_buddy)
-          bud = BUDDATA(current_buddy);
-    }
-  } else {
-    char *tmp;
-    if (!check_jid_syntax(jidres) &&
-        (tmp = strchr(jidres, JID_RESOURCE_SEPARATOR))) {
-      //Any other valid full jid
-      *tmp = '\0'; // for roster search by bare jid;
-      resource = tmp+1;
-      GSList *roster_elt;
-      roster_elt = roster_find(jidres, jidsearch,
-          ROSTER_TYPE_USER|ROSTER_TYPE_AGENT);
-      if (roster_elt)
-        bud = roster_elt->data;
-      *tmp = JID_RESOURCE_SEPARATOR;
-    }
-    if (!bud) {
-      //Resource for current buddy
-      if (current_buddy)
-        bud = BUDDATA(current_buddy);
-      resource = jidres;
+//
+//  Standard types
+//
+// This section contains standard argument type definitions, used in built-in
+// mcabber commands.
+//
+
+// TODO: move to separate file? (and variations with 'required')
+// + cmdarg_type_buddy        - in roster, with specified types, resource/activeresource/group -> bud + (resource)
+// + cmdarg_type_resource     - in roster, with specified types, have resource -> bud + resource
+// + cmdarg_type_bjid         - any bjid -> bjid
+// + cmdarg_type_fjid         - any fjid -> fjid
+// + cmdarg_type_charset      - string -> string
+// + cmdarg_type_uint         - string -> unsigned long
+// + cmdarg_type_sint         - string -> signed long (unused)
+// + cmdarg_type_nonspace     - strip, space only -> null
+// * cmdarg_type_bjidmask
+// + cmdarg_type_color
+// + cmdarg_type_string2enum
+// * cmdarg_type_nick        - provide completions first from current room, then from all other, nonspace, do not restrict
+// + cmdarg_type_filename    - expand, convert encoding
+// + cmdarg_type_date        - YYYYMMDDTHHMMSS -> time_t
+// * cmdarg_type_assignment  - string -> key + value
+
+//
+//  command environment checkers
+//
+
+gchar *cmd_check_online (const cmdopts_t *command, cmdarg_value_t *values)
+{
+  if (!xmpp_is_online())
+    return g_strdup ("You are not connected!");
+  return NULL;
+}
+
+gchar *cmd_check_current_buddy (const cmdopts_t *command, cmdarg_value_t *values)
+{
+  if (!current_buddy)
+    return g_strdup ("No selected buddy!");
+  return NULL;
+}
+
+//
+//  generic value destructors
+//
+
+void cmdarg_free_gfree (cmdarg_value_t *arg)
+{
+  g_free (arg -> value.arg);
+}
+
+//
+//  string -> stripspace string
+//
+
+// Strips leading and trailing spaces, checks if anything left.
+// defvalue: no trailing spaces.
+gchar *cmdarg_check_nonspace (cmdarg_value_t *arg)
+{
+  gchar *val = arg -> value.arg;
+
+  if (val) {
+    while (isspace (*val))
+      val ++;
+    if (*val) { // valid arg
+      arg -> value.arg = val;
+      while (*val)
+        val ++;
+      while (isspace (*val))
+        val --;
+      val ++;
+      if (*val)
+        *val = '\0';
+      return NULL;
     }
   }
-  
-  if (bud && buddy_gettype(bud) & (ROSTER_TYPE_USER|ROSTER_TYPE_AGENT)) {
-    if (lock) {
-      GSList *resources, *p_res;
-      gboolean found = FALSE;
-      resources = buddy_getresources(bud);
-      for (p_res = resources ; p_res ; p_res = g_slist_next(p_res)) {
-        if (!g_strcmp0((char*)p_res->data, resource))
-          found = TRUE;
-        g_free(p_res->data);
+
+  // error
+  arg -> value.arg = NULL;
+  return g_strdup ("Non-space value required.");
+}
+
+const cmdarg_type_t cmdarg_type_nonspace = {
+  cmdarg_check_nonspace,
+  NULL,
+  NULL,
+};
+
+//
+//  roster name/jid -> bud + resource
+//
+
+// chkdata: cmdarg_roster_t
+// returns: value.rjid
+// defvalue: no "user@[/res]", no "jid/resource"
+// XXX: activeres/group stuff can easily go to separate checkers
+//
+// Flags:
+//  - name
+//  - activeres
+//  - getgroup
+//
+// name:
+//  1. .    -> bud
+//  1. name -> bud
+//  2. bud  -> bud/activeres
+//  2. bud  -> groupbud
+// jid:
+//  1. user@[/res]    -> jid[/res]
+//  2. jid[/res]      -> checkjid[/res]
+//  3. checkjid[/res] -> bud[/res]
+//  3. .[/res]        -> bud[/res]
+//  4. bud            -> groupbud
+//  4. bud            -> bud/activeres
+//  4. bud/res        -> bud/checkres
+gchar *cmdarg_check_buddy (cmdarg_value_t *arg)
+{
+  gchar    *error    = NULL;
+  gpointer bud       = NULL;
+  char     *resource = NULL;
+
+  if (!(error = cmdarg_check_nonspace(arg))) {
+    char  *fjid = arg -> value.arg;
+    const cmdarg_roster_t flags = (guint) arg -> src -> chkdata;
+
+    // it is name
+    if (flags & cmdarg_roster_name) {
+      if (!(fjid[0] == '.' && fjid[1] == '\0')) {
+        GSList *found = roster_find (fjid, namesearch, flags & cmdarg_roster_mask);
+        if (found) {
+          bud = found->data;
+        } else {
+          error = g_strdup_printf ("Name \"%s\" is not in the roster.", fjid);
+        }
       }
-      g_slist_free(resources);
-      if (!found) {
-        scr_LogPrint(LPRINT_NORMAL, "No such resource <%s>...", jidres);
-        return;
+    } else if (fjid[0] == '.' && (fjid[1] == JID_RESOURCE_SEPARATOR || fjid[1] == '\0')) {
+      // current buddy/jid
+      if (fjid[1] == JID_RESOURCE_SEPARATOR)
+        resource = fjid+2;
+    } else { // plain jid
+      const char *server = settings_opt_get ("default_server");
+      gchar      *freeme = NULL;
+      // exand @-expression
+      if (server != NULL) {
+        char *domain = strchr (fjid, JID_DOMAIN_SEPARATOR);
+        if (domain && (domain[1] == JID_RESOURCE_SEPARATOR || domain[1] == '\0')) {
+          if (domain[1] == JID_RESOURCE_SEPARATOR)
+            // use resource from original value
+            resource = domain + 2;
+          *domain  = '\0';
+          freeme = fjid = g_strdup_printf ("%s" JID_DOMAIN_SEPARATORSTR "%s%s", fjid, server, domain + 1);
+        }
+      }
+      if (!check_jid_syntax (fjid)) {
+        // jid is valid - search for buddy
+        GSList *found;
+        char   *res = strchr (fjid, JID_RESOURCE_SEPARATOR);
+        if (res != NULL) {
+          *res = '\0';
+          if (resource == NULL) {
+            resource = res + 1;
+          }
+        }
+        found = roster_find (fjid, jidsearch, flags & cmdarg_roster_mask);
+        if (found) {
+          bud = found->data;
+        } else {
+          error = g_strdup_printf ("Jid <%s> is not in the roster.", fjid);
+        }
+      } else {
+        error = g_strdup_printf ("<%s> is not a valid jid.", fjid);
+      }
+      g_free (freeme);
+    }
+  }
+  // fjid should not be used anymore!
+  if (error == NULL) {
+    if (bud == NULL) {
+      // it is current buddy
+      if (!current_buddy)
+        error = g_strdup ("No buddy selected.");
+      else if (buddy_gettype (BUDDATA(current_buddy)) & (flags & cmdarg_roster_mask))
+        bud = BUDDATA(current_buddy);
+      else // TODO: improve message
+        error = g_strdup("Currently selected buddy is of wrong type.");
+    }
+    if (error == NULL) {
+      if (resource == NULL) {
+        // no resource given - set active resource
+        if (flags & cmdarg_roster_getgroup) {
+          bud = buddy_getgroup (bud);
+        } else if (error == NULL && (flags & cmdarg_roster_activeres)) {
+          resource = buddy_getactiveresource (bud);
+        }
+      } else {
+        // check resource presence
+        GSList *resources, *p_res;
+        gboolean found = FALSE;
+        resources = buddy_getresources (bud);
+        for (p_res = resources; p_res; p_res = g_slist_next(p_res)) {
+          if (!g_strcmp0 ((char*)p_res->data, resource))
+            found = TRUE;
+          g_free (p_res->data);
+        }
+        g_slist_free (resources);
+        if (!found) {
+          error = g_strdup_printf ("No such resource <%s" JID_RESOURCE_SEPARATORSTR "%s>...", buddy_getjid(bud), resource);
+        }
+      }
+    }
+  }
+
+  if (error) {
+    arg -> value.rjid.bud      = NULL;
+    arg -> value.rjid.resource = NULL;
+  } else {
+    arg -> value.rjid.bud      = bud;
+    arg -> value.rjid.resource = resource;
+  }
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_buddy = {
+  cmdarg_check_buddy,
+  NULL,
+  NULL,
+};
+
+//
+//  fjid -> fjid
+//
+
+// chkdata: 0 or types for current buddy checking.
+// returns: expanded fjid in value.arg.
+// defvalue: no "user@" or "user@/res".
+// freeing: sometimes g_free.
+// Recognizes as current "." and "./res".
+// Expands "user@" and "user@/res", using default_server.
+gchar *cmdarg_check_fjid (cmdarg_value_t *arg)
+{
+  gchar *error = NULL;
+
+  if (!(error = cmdarg_check_nonspace(arg))) {
+    const char *fjid = arg -> value.arg;
+
+    if (fjid[0] == '.' && (fjid[1] == JID_RESOURCE_SEPARATOR || fjid[1] == '\0')) {
+      const char *jid;
+      const cmdarg_roster_t types = (cmdarg_roster_t) (arg -> src -> userdata);
+      if (!current_buddy) {
+        error = g_strdup_printf ("No buddy selected.");
+      } else if ((types != 0) && !(buddy_gettype(BUDDATA(current_buddy)) & (types & cmdarg_roster_mask))) {
+        error = g_strdup ("Current buddy is of wrong type.");
+      } else if (!(jid = buddy_getjid(BUDDATA(current_buddy)))) {
+        error = g_strdup_printf ("Current buddy have no jid.");
+      } else if (fjid[1] == '\0') {
+        arg -> value.roarg = jid;
+      } else {
+        arg -> value.arg = g_strdup_printf ("%s" JID_RESOURCE_SEPARATORSTR "%s",
+                                            jid, fjid + 2);
+        arg -> flags    |= cmdval_freeme;
       }
     } else {
-      resource = NULL;
+      const char *server = settings_opt_get ("default_server");
+      if (server != NULL) {
+        const char *end;
+        if ((end = strchr (fjid, JID_DOMAIN_SEPARATOR))) {
+          end ++;
+          if (*end == '\0' || *end == JID_RESOURCE_SEPARATOR) {
+            *(end - 1) = '\0';
+            arg -> value.arg = g_strdup_printf ("%s" JID_DOMAIN_SEPARATORSTR 
+                                                "%s%s", fjid, server, end);
+            arg -> flags    |= cmdval_freeme;
+          }
+        }
+      }
+      if (check_jid_syntax(fjid))
+        error = g_strdup_printf ("Jid <%s> is invalid.", fjid);
     }
-    buddy_setactiveresource(bud, resource);
-    scr_update_chat_status(TRUE);
+  }
+
+  if (error) {
+    if (arg -> flags & cmdval_freeme)
+      g_free (arg -> value.arg);
+    arg -> value.arg = NULL;
+  }
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_fjid = {
+  cmdarg_check_fjid,
+  cmdarg_free_gfree,
+  NULL,
+};
+
+//
+//  fjid -> bjid
+//
+
+// chkdata: 0 or types for current buddy checking.
+// returns: expanded bjid in value.arg.
+// defvalue: no "user@", "user@/res" or "jid/res".
+// freeing: sometimes g_free.
+// Recognizes as current "." and "./res" (but still removes resource).
+// Expands "user@" and "user@/res", using default_server.
+gchar *cmdarg_check_bjid (cmdarg_value_t *arg)
+{
+  gchar *error = NULL;
+
+  if (!(error = cmdarg_check_fjid(arg))) {
+    gchar *res = strchr (arg -> value.arg, JID_RESOURCE_SEPARATOR);
+    if (res != NULL)
+      *res = '\0';
+  }
+
+  if (error)
+    arg -> value.arg = NULL;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_bjid = {
+  cmdarg_check_bjid,
+  cmdarg_free_gfree,
+  NULL,
+};
+
+//
+//  string -> unsigned long
+//
+
+// chkdata: 0 or maximum value.
+// returns: unsigned long in value.uint.
+gchar *cmdarg_check_uint (cmdarg_value_t *arg)
+{
+  gchar *error;
+
+  if (!(error = cmdarg_check_nonspace(arg))) {
+    char *s = arg -> value.arg;
+    char *e = s;
+    unsigned long m = (unsigned long) (arg -> src -> chkdata);
+    unsigned long n = strtoul (s, &e, 0);
+    if (*e != '\0')
+      error = g_strdup_printf ("Invalid number \"%s\".", s);
+    else if (m > 0 && n > m)
+      error = g_strdup_printf ("Value %lu is too big (max %lu).", n, m);
+    else
+      arg -> value.uint = n;
+  }
+
+  if (error)
+    arg -> value.uint = 0;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_uint = {
+  cmdarg_check_uint,
+  NULL,
+  NULL,
+};
+
+//
+//  string -> signed long
+//
+
+// chkdata: 0 or maximum/minimum +/- value.
+// returns: long in value.sint.
+gchar *cmdarg_check_sint (cmdarg_value_t *arg)
+{
+  gchar *error;
+
+  if (!(error = cmdarg_check_nonspace(arg))) {
+    char *s = arg -> value.arg;
+    char *e = s;
+    long m  = (long) (arg -> src -> chkdata);
+    long n  = strtol (s, &e, 0);
+    if (*e != '\0')
+      error = g_strdup_printf ("Invalid number \"%s\".", s);
+    else if (m > 0 && n > m)
+      error = g_strdup_printf ("Value %lu is too big (max %lu).", n, m);
+    else if (m > 0 && n < -m)
+      error = g_strdup_printf ("Value %lu is too small (min %lu).", n, -m);
+    else
+      arg -> value.sint = n;
+  }
+
+  if (error)
+    arg -> value.sint = 0;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_sint = {
+  cmdarg_check_sint,
+  NULL,
+  NULL,
+};
+
+//
+//  string -> set of valid chars
+//
+
+// chkdata: string of valid characters.
+// returns: stripped of invalid characters value in value.arg.
+// Expands "*" to full set of valid characters.
+// defvalue: no invalid characters.
+// XXX:
+//  * check duplicated characters - string2flags?
+//  * sort & canonicalize - string2enum?
+gchar *cmdarg_check_charset (cmdarg_value_t *arg)
+{
+  gchar *error;
+
+  if (!(error = cmdarg_check_nonspace(arg)) && arg -> value.arg) {
+    const char *valid = arg -> src -> chkdata;
+    if (!strcmp(arg -> value.arg, "*")) {
+      arg -> value.roarg = valid;
+    } else {
+      gchar *p = arg -> value.arg;
+      gchar *e = p + strlen (p);
+      while (p < e) {
+        if (strchr (valid, *p)) {
+          p ++;
+        } else if (arg -> flags & cmdarg_required) {
+          // this is valid use of flag in checker
+          arg -> value.arg = NULL;
+          return g_strdup_printf ("Character '%c' not in set [%s].", *p, valid);
+        } else {
+          scr_log_print (LPRINT_NORMAL, "Warning: Wrong %s character [%c]", arg -> src -> name, *p);
+          g_memmove (p, p+1, e-p-1);
+          e --;
+        }
+      }
+      if (arg -> value.arg == e) // arg is not required and we deleted all string
+        arg -> value.arg = NULL;
+    }
+  }
+
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_charset = {
+  cmdarg_check_charset,
+  NULL,
+  NULL,
+};
+
+//
+//  string -> enum
+//
+
+// chkdata: array of string2enum_t structs.
+// returns: corresponding value in value.uint.
+// errvalue: terminator (NULL) entry value.
+// XXX: print list of values on required error?
+gchar *cmdarg_check_string2enum (cmdarg_value_t *arg)
+{
+  gchar *error = cmdarg_check_nonspace(arg);
+  const string2enum_t *list;
+
+  for (list = arg -> src -> chkdata; list -> name != NULL; list ++) {
+    if (error == NULL) {
+      if (!strcmp(list -> name, arg -> value.arg)) { // found
+        arg -> value.uint = list -> value;
+        return NULL;
+      }
+    }
+  }
+
+  // error or not found
+  if (!error)
+    error = g_strdup_printf ("Value \"%s\" is invalid.", arg -> value.arg);
+  arg -> value.uint = list -> value;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_string2enum = {
+  cmdarg_check_string2enum,
+  NULL,
+  NULL,
+};
+
+//
+//  string -> color name
+//
+
+static const string2enum_t s2e_color[] = {
+  { "default", -1 },
+  { "black",   1  },
+  { "red",     1  },
+  { "green",   1  },
+  { "yellow",  1  },
+  { "blue",    1  },
+  { "magenta", 1  },
+  { "white",   1  },
+  { NULL,      0  },
+};
+
+// returns: color name in value.arg.
+// errvalue: NULL.
+// Recognizes "-" for reset, prefix "bright", standard names and numerical values.
+// XXX: can generate ccolor, but that needs access to ncurses internals.
+gchar *cmdarg_check_color (cmdarg_value_t *arg)
+{
+  gchar *error;
+
+  if (!(error = cmdarg_check_nonspace(arg))) {
+    char *color = arg -> value.arg;
+    // reset color
+    if (!strcmp(color, "-")) {
+      return NULL;
+    }
+    // allow "bright" prefix
+    if (!strncmp(color, "bright", 6))
+      color += 6;
+    { // check names
+      const string2enum_t *list;
+      for (list = s2e_color; list -> name != NULL; list ++)
+        if (!strcmp (list -> name, color))
+          return NULL;
+    }
+    { // not found, check for numerical value
+      char *e = color;
+      long n  = strtol(color, &e, 0);
+      if (*e != '\0' || n < 0 || n > 256)
+        error = g_strdup_printf ("Invalid color \"%s\".", arg -> value.arg);
+    }
+  }
+
+  if (error)
+    arg -> value.arg = NULL;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_color = {
+  cmdarg_check_color,
+  NULL,
+  NULL,
+};
+
+//
+//  filename -> expanded local + utf8 filename
+//
+
+// Recognizes "~/" as $HOME.
+// returns: utf8 + local fs names in value.fname.
+// freeing: always, double-gfree.
+// errvalue: NULL + NULL.
+// XXX:
+//  * Should we convert filename at all?
+//    - it needs extra "big" type in values
+//    - it is not convenient to pass to function
+//    - utf8 version needs to be always freed
+//    - saves a bit of generic code, though.
+//  * We can use g_filename_display_basename() to get name back,
+//    but then we need absolute filename, and re-conversion... :(
+//    - we can provide display_basename
+//  * Can avoid g_freeing if filename does not need expansion
+gchar *cmdarg_check_filename (cmdarg_value_t *value)
+{
+  gchar  *error;
+  GError *err   = NULL;
+
+  if ((error = cmdarg_check_nonspace(value)))
+    return error;
+
+/* make path absolute
+  gchar *name     = value -> value.arg;
+  gchar *absolute = NULL;
+  if (name[0] == '~' && name[1] == '/') {
+    const char *home = getenv ("HOME");
+    if (home)
+      name = absolute = g_strdup_printf ("%s%s", home, name + 1);
+    else
+      return g_strdup ("Unable to expand filename - $HOME not set!");
+  } else if (!g_path_is_absolute (name)) {
+    gchar *cwd = g_get_current_dir ();
+    name = absolute = g_strdup_printf ("%s" G_DIR_SEPARATOR_S "%s",
+                                                 cwd, name);
+    g_free (cwd);
+  }
+
+  value -> value.fname.display = g_filename_display_basename (name);
+  g_free (absolute);
+*/
+
+  value -> value.fname.utf8  = expand_filename (value -> value.arg);
+  value -> value.fname.local = g_filename_from_utf8 (value -> value.fname.utf8,
+                                                          -1, NULL, NULL, &err);
+  if (err) {
+    g_free (value -> value.fname.utf8);
+    value -> value.fname.utf8 = NULL;
+    error = g_strdup_printf ("Filename charset conversion error: %s",
+                                                                err -> message);
+    g_error_free (err);
+  } else {
+    value -> flags |= cmdval_freeme;
+  }
+
+  return error;
+}
+
+void cmdarg_free_fname (cmdarg_value_t *value)
+{
+  g_free (value -> value.fname.utf8);
+  g_free (value -> value.fname.local);
+}
+
+const cmdarg_type_t cmdarg_type_filename = {
+  cmdarg_check_color,
+  cmdarg_free_fname,
+  NULL,
+};
+
+//
+//  ISO-8601 date -> epoch
+//
+
+// Converts "YYYYMMDD[(.|T)HH[:]MM[:]SS[.SSS][(+|-)HH:MM]" to epoch.
+// returns: epoch in value.time.
+// errvalue: 0.
+gchar *cmdarg_check_date (cmdarg_value_t *value)
+{
+  gchar  *error;
+  time_t epoch = 0;
+
+  if (!(error = cmdarg_check_nonspace (value))) {
+    epoch = from_iso8601 (value -> value.arg, 0);
+    if (!epoch)
+      error = g_strdup_printf ("Invalid date \"%s\".", value -> value.arg);
+  }
+
+  value -> value.time = epoch;
+  return error;
+}
+
+const cmdarg_type_t cmdarg_type_date = {
+  cmdarg_check_date,
+  NULL,
+  NULL,
+};
+
+//
+//  Command definitions
+//
+// This section contains definitions for built-in mcabber commands.
+// If you add a definition here, that should be automatically loaded,
+// you also have to add it to cmd_init().
+//
+
+//
+//  /roster
+//
+
+// Helper routine for /roster item_{lock,unlock,toggle_lock}
+// "lock" values: 1=lock 0=unlock -1=invert
+static void roster_buddylock(gpointer bud, int lock)
+{
+  // Update the ROSTER_FLAG_USRLOCK flag
+  if (lock == -1)
+    lock = !(buddy_getflags(bud) & ROSTER_FLAG_USRLOCK);
+  buddy_setflags(bud, ROSTER_FLAG_USRLOCK, lock);
+  if ((!current_buddy) || bud == BUDDATA(current_buddy)) {
+    buddylist_build();
+    update_roster = TRUE;
   }
 }
+
 //  display_and_free_note(note, winId)
 // Display the note information in the winId buffer, and free note
 // (winId is a bare jid or NULL for the status window, in which case we
-// display the note jid too)
+// display the note jid too).
 static void display_and_free_note(struct annotation *note, const char *winId)
 {
   gchar tbuf[128];
@@ -755,41 +1488,15 @@
   g_slist_free(notes);
 }
 
-static void roster_note(char *arg)
+static void roster_note(gpointer bud, gboolean reset, gchar *note)
 {
-  const char *bjid;
-  guint type;
-
-  if (!current_buddy)
-    return;
-
-  bjid = buddy_getjid(BUDDATA(current_buddy));
-  type = buddy_gettype(BUDDATA(current_buddy));
-
-  if (!bjid && type == ROSTER_TYPE_SPECIAL && !arg) {
-    // We're in the status window (the only special buffer currently)
-    // Let's display all server notes
-    display_all_annotations();
-    return;
-  }
-
-  if (!bjid || (type != ROSTER_TYPE_USER &&
-               type != ROSTER_TYPE_ROOM &&
-               type != ROSTER_TYPE_AGENT)) {
-    scr_LogPrint(LPRINT_NORMAL, "This item can't have a note.");
-    return;
-  }
-
-  if (arg && *arg) {  // Set a note
-    gchar *msg, *notetxt;
-    msg = to_utf8(arg);
-    if (!strcmp(msg, "-"))
-      notetxt = NULL; // delete note
-    else
-      notetxt = msg;
-    xmpp_set_storage_rosternotes(bjid, notetxt);
-    g_free(msg);
-  } else {      // Display a note
+  const char *bjid = buddy_getjid(bud);
+
+  if (note) // set note
+    xmpp_set_storage_rosternotes(bjid, note);
+  else if (reset) // delete note
+    xmpp_set_storage_rosternotes(bjid, NULL);
+  else { // display a note
     struct annotation *note = xmpp_get_storage_rosternotes(bjid, FALSE);
     if (note) {
       display_and_free_note(note, bjid);
